package com.yuandian.dataflow.statemachine.closure;

import com.alipay.sofa.jraft.Closure;
import com.alipay.sofa.jraft.entity.PeerId;
import com.yuandian.dataflow.statemachine.rpc.RaftResponse;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Getter
@Setter
@ToString
public  abstract  class  GenericClosure   implements Closure {
 
 
	// 状态机的统一响应
	private RaftResponse  response;
	// 代表任务状态 
	private Object value;

    public <T> T getValue() {
        if(this.value == null) {
            return null;
        }
        return (T)this.value;
    }

    public GenericClosure() {
  
    }

	/**
     * 错误的时候返回错误信息.  自动装配response
	 * @param errorMsg
	 * @param redirect
	 */
	public void failure(final String errorMsg, final PeerId redirect) {
        final RaftResponse response = new RaftResponse();
        response.setSuccess(false);
        response.setMsg(errorMsg);
        log.error("{}", errorMsg);
        response.setRedirect(redirect);
        setResponse(response);
    }

    /**
     * 成功时调用该方法. 自动装配response
     * @param value
     */
    public void success(final Object value) {
        final RaftResponse  response = new RaftResponse ();
        response.setValue(value);
        response.setSuccess(true);
        setResponse(response);
    }
}
